<?php

/*
	Copyright 2004 
	John Rankin john.rankin@affinity.co.nz

        Based on guestbook and journal to allow diary and comment pages
*/

SDV($DiaryEntryFmt,"<div id='diary'><form action='\$PageUrl' method='post'>
	<input type='hidden' name='pagename' value='\$PageName' />
	<input type='hidden' name='action' value='jpost' />
	<table width='100%'><tr>
	<td class='prompt'>New entry</td>
	<td><textarea name='text' rows='6' cols='45' wrap='virtual'></textarea><br />
	<input type='submit' value=' Post ' />
	<input type='reset' value='Reset' /></td></tr></table></form></div>");
SDV($MessageEntryFmt,"<div id='message'><form action='\$PageUrl' method='post'>
	<input type='hidden' name='pagename' value='\$PageName' />
	<input type='hidden' name='action' value='jpost' />
	<input type='hidden' name='order' value='\$Chrono' />
	<table width='100%'><tr>
	<td class='prompt'>Message</td>
	<td><textarea name='text' rows='6' cols='45' wrap='virtual'></textarea>
	</td></tr><tr><td class='prompt'>Author</td>
	<td><input type='text' name='author' value='' size='32' />
	<input type='submit' value=' Post ' />
	<input type='reset' value='Reset' /></td></tr></table></form></div>");
SDV($CalendarEntryFmt,"<div id='message'><form action='\$PageUrl' method='post'>
	<input type='hidden' name='pagename' value='\$PageName' />
	<input type='hidden' name='action' value='jpost' />
	<input type='hidden' name='order' value='x\$Chrono' />
	<table width='100%'><tr>
	<td class='prompt'>Headline</td>
	<td><input type='text' name='headline' value='' size='45' /></td></tr>
	<tr><td class='prompt'>Story</td>
	<td><textarea name='text' rows='7' cols='45' wrap='virtual'></textarea></td></tr>
	<tr><td class='prompt'>Author</td>
	<td><input type='text' name='author' value='' size='32' />
	<input type='submit' value=' Post ' />
	<input type='reset' value='Reset' /></td></tr></table></form></div>");
if ("$JournalDateFmt" == "") $JournalDateFmt = '%d %B %Y';
if ("$JournalTimeFmt" == "") $JournalTimeFmt = '%H:%M';
if ("$JournalPattern" == "") $JournalPattern = '/Journal$/';
if ("$DiaryPattern" == "") $DiaryPattern = '/Diary$/';
if (preg_match($JournalPattern,$pagename)||preg_match($DiaryPattern,$pagename))
   { if ($action=='browse') $PageCommentFmt = $DiaryEntryFmt; }
if ($action == 'jpost') { 
    SDV($HandleActions['jpost'],'HandleJDMPost');
} else if ($action=='print' || $action=='publish') {
          $InlineReplacements['/\\[\\[\\$Comment(chrono)?\\]\\]/'] = '';
          $InlineReplacements['/\\[\\[\\$Wikilog(chrono)?\\]\\]/'] = '';
} else { SDV($InlineReplacements['/\\[\\[\\$Comment(chrono)?\\]\\]/e'],
             "str_replace('\$Chrono','\$1',
               FmtPageName(\$GLOBALS['MessageEntryFmt'],\$pagename))"); 
         SDV($InlineReplacements['/\\[\\[\\$Wikilog(chrono)?\\]\\]/e'],
             "str_replace('\$Chrono','\$1',
               FmtPageName(\$GLOBALS['CalendarEntryFmt'],\$pagename))"); 
}

function HandleJDMPost($pagename) {
  global $_POST,$JournalPattern,$DiaryPattern;
  if ($_POST['order'][0]=='x') {
      HandleWikilogPost($pagename);
  } else {
      $_POST['text'] = IndentParagraphs(stripmagic($_POST['text']));
      if (preg_match($JournalPattern,$pagename)) HandleJournalPost($pagename);
      elseif (preg_match($DiaryPattern,$pagename)) HandleDiaryPost($pagename);
      else HandleMessagePost($pagename);
  }
}

function HandleJournalPost($pagename) {
   global $_POST, $JournalDateFmt, $JournalTimeFmt;
   $page = RetrieveAuthPage($pagename, "edit");
   $now  = time();
   $date = "!!!!".strftime($JournalDateFmt,$now);
   $time = ":[=".strftime($JournalTimeFmt,$now). "=]:";
   $repl = "$date\n\n$time" . $_POST['text'];
   if (strstr($page['text'], $date)) {
      $_POST['text'] = str_replace($date, $repl, $page['text']);
   } else { 
      $_POST['text'] = "$repl\n\n" . $page['text'];
   }
   HandlePost($pagename);
   exit;
}

function HandleDiaryPost($pagename) {
   global $_POST, $JournalDateFmt;
   $page = RetrieveAuthPage($pagename, "edit");
   $now  = time();
   $date = ":".strftime($JournalDateFmt,$now). ":";
   if (strstr($page['text'], $date)) {
      $repl = $date . $_POST['text'] . "\n\n: :";
      $_POST['text'] = str_replace($date, $repl, $page['text']);
   } else { 
      $_POST['text'] = $date . $_POST['text'] . "\n\n" . 
                                        $page['text'];
   }
   HandlePost($pagename);
   exit;
}

function HandleMessagePost($pagename) {
   global $_POST, $JournalDateFmt, $JournalTimeFmt;
   $name = $_POST['author'];
   $name = ($name=='') ? 'anonymous' : '{{~' . $name . '}}';
   $now  = time();
   $date = "!!!!".strftime($JournalDateFmt,$now);
   $time = ":[=".strftime($JournalTimeFmt,$now). "=] by '''$name''':";
   $page = RetrieveAuthPage($pagename, "edit");
   $order= $_POST['order'];
   if ($order=='') {
      if (strstr($page['text'],'[[$Comment]]')) {
         $pos = strpos($page['text'],'[[$Comment]]');
         $len = strlen('[[$Comment]]');
         $before = substr($page['text'],0,$pos+$len);
         $after  = substr($page['text'],$pos+$len);
      } else {
         $before = '';
         $after  = $page['text'];
      }
      $repl  = "$date\n\n$time" . $_POST['text'];
      if (strstr($after, $date)) {
         $after = str_replace($date, $repl, $after);
      } else { 
         $after = "\n$repl\n$after";
      }
      $_POST['text'] = "$before$after";
   } else {
      if (strstr($page['text'],'[[$Commentchrono]]')) {
         $pos = strpos($page['text'],'[[$Commentchrono]]');
         $before = substr($page['text'],0,$pos);
         $after  = substr($page['text'],$pos);
      } else {
         $before = $page['text'];
         if ($before[strlen($before)-1]!='\n') $before .="\n\n";
         $after  = '';
      }
      if (strstr($before, $date)) {
         $repl  = "$time";
      } else { 
         $repl  = "$date\n\n$time";
      }
      $repl .= $_POST['text'] . "\n\n";
      $_POST['text'] = "$before$repl$after";
   }
   HandlePost($pagename);
   exit;
}

function IndentParagraphs($text) {
   global $AnyLetter;
   $text = preg_replace("/\n($AnyLetter)/","\n->$1",$text);
   $text = preg_replace("/\n([#*])([^#*])/","\n$1$1$2",$text);
   return preg_replace("/\n:([^:]+):/","\n::$1:",$text);
}

function HandleWikilogPost($pagename) {
   global $_POST,$JournalTimeFmt;
   $name = $_POST['author'];
   $name = ($name=='') ? 'anonymous' : '{{~' . $name . '}}';
   $now = time();
   $_POST['text']= "!!!!".$_POST['headline']."\n".
                   $_POST['text']."\n\n=>[-Posted at ".
                   strftime($JournalTimeFmt,$now)." by $name-]";
   $todayspage = FmtPageName('$Group',$pagename)."/".strftime("%Y%m%d",$now);
   if (PageExists($todayspage)) {
      $page = RetrieveAuthPage($todayspage, "edit");
      $_POST['text'] = ($_POST['order']=='x') ? 
                        $_POST['text'] . "\n\n" . $page['text'] : 
                        $page['text'] . "\n\n" . $_POST['text'];
   }
   HandlePost($todayspage);
   exit;
}

?>