<?php

if ($space_date_titles) $AsSpacedFunction = 'WikilogAsSpaced';
else $AsSpacedFunction = 'SmarterAsSpaced';
$StopList = array(
		'A',
		'An',
		'And',
		'But',
		'By',
		'For',
		'From',
		'In',
		'Is',
		'It',
		'Of',
		'On',
		'Or',
		'The',
		'To',
            );

function WikilogAsSpaced($word) {
  global $SpaceDateString;
  if (IsDate($word)) return preg_replace('/^(....)(..)/',
                                 "$1$SpaceDateString$2$SpaceDateString",$word);
  return SmarterAsSpaced($word);
}

function SmarterAsSpaced($word) {
  global $SpaceWikiWordsString,$StopList;
  $word = AsSpaced($word);
  foreach ($StopList as $s)
    $word = preg_replace("/($SpaceWikiWordsString$s$SpaceWikiWordsString)/e",
                 "strtolower('$1')",$word);
  return $word;
}

?>
