<?php

/*
  This controls addition of free link functionality, to make sure parsing
  happens in the correct order.

  Copyright 2003, 2004 John Rankin john.rankin@affinity.co.nz
*/

#$AnyLetter = "[A-Za-z0-9]";
$AnyLetter = "[[:alnum:]]";
$PageNameSpace = "";
#$PageNameSpace = "_";
#$TitleWord = "[A-Z0-9]($AnyLetter*)(-($AnyLetter+))*";
#$PageTitlePattern = "($TitleWord)(_($TitleWord))*";
$TitlePattern = "[A-Z0-9]$AnyLetter*";
$PageTitlePattern = "$TitlePattern(?:-$AnyLetter+)*(?:~$TitlePattern)?";
$PageNamePattern = "($GroupNamePattern)([.\\/])($PageTitlePattern)";
$GroupFreeLinkPattern="{{(?>(?:($GroupNamePattern)([.\\/]))?([[:alnum:]]+(?:(?:[\\s_]*|[-~])[[:alnum:]]+)*)(?:\\|((?:(?:[\\s_]*|[-~])[[:alnum:]])*))?)}}((?:-?[[:alnum:]]+)*)";
$FreeLinkPattern = $GroupFreeLinkPattern;
$ClassicFreeLinkPattern="{{($AnyLetter+(?:(?:\s*|[-~])$AnyLetter+)*)(?:\\|((?:(?:\s*|[-~])$AnyLetter)*))?}}((-?$AnyLetter)*)";
$GroupLinkPattern = "(($GroupNamePattern)([.\\/]))?($ClassicFreeLinkPattern)";
$PageLinkPattern = 
  "($PageNamePattern)|($GroupLinkPattern)|($WikiWordPattern)";

function Wikify($word) {
  global $PageNameSpace;
  $linktext = preg_replace("/{{(.*)}}.*/","$1",str_replace("|","",$word));
  return preg_replace("/\s+/",$PageNameSpace,ucwords($linktext));
}

function QualifyLink($thisgroup,$link) {
  if (preg_match("/[.\\/]/",$link)) { return $link; }
  else { return "$thisgroup/$link"; }
}

?>