<?php
/*
This is the default Wikilog PmWiki distribution
All scripts Copyright 2004 john.rankin@affinity.co.nz
*/

# load the style sheet
$HTMLHeaderFmt[] = 
 "<link rel='stylesheet' href='\$PubDirUrl/css/wikilog.css' type='text/css' />";

# shared services
$scriptlocation = 'wikilog';
include_once("$FarmD/local/$scriptlocation/freesupport.php");

# set the language (defaults to 'en')
#$language = 'de';

# disable the Publish button
#$PublishCalendarTagFmt = '';

# markup extensions
include_once("$FarmD/local/$scriptlocation/wikilog.php");

// =========================================================================
// Configuration variables (default settings shown)
// =========================================================================

// This configures how weekdays are presented.
// 0 - american style, Sun to Sat
// 1 - european style, Mon to Sun
#$calendar_weekstyle=1;

// This configures how dates are presented.
// 0 - american style, 11/17/2002
// 1 - european style, 17.11.2002
// 2 - international style, 2002-11-17
#$calendar_datestyle=1;
#$space_date_titles =1;
#$SpaceDateString=' ';

// How many months relative to the current one to start the calendar.
// Can be a negative (going back) or a positive (going ahead) number.
// The value zero (0) starts the calendar with the current month.
#$calendar_months_start=0;

// How many months altogether to show on the calendar.
#$calendar_months_number=2;

// How many months after we should wrap and start a new row.
#$calendar_month_wrap=3;

// Whether or not to display current entries at the bottom of the calendar.
// Enter 'false' to omit the current period's entries.
#$display_log_entries=true;

// Whether to display current entries in ascending or descending order.
// Enter 'false' to show the oldest first.
#$newest_first=true;

// Whether to display a summary or full calendar on individual entry pages.
// Enter 'false' to include the calendar on every page.
#$summary_only=true;

// This is the default home of each collection (Group) of date pages.
#$wikilog_home_page= "{{" . FmtPageName('$Group',$pagename) . "}}";

// Whether to display non-existent date entries in the calendar as day or day?
// Enter 'true' to use the wiki '?' convention for non-existent entries
#$day_as_wiki=false;

// Whether to display a list or list and Publish button on wikilog news pages
// Enter 'true' to omit the Publish button after the news list
#$news_list_only=false;

// Set depending on whether you need ThisPage:?logdate= or ThisPage:&logdate=
#$UrlConnector = "?";
#$UrlConnector = "&";

// =========================================================================
// End of configuration variables
// =========================================================================

# provide support for `EscapedWikiWords and the stop character (`.)
include("$FarmD/local/$scriptlocation/escapewiki.php");

# provide support for [[$Wikilog]] -- a form to post entries for 'today'
include_once("$FarmD/local/$scriptlocation/extended-journal.php");
include_once("$FarmD/local/$scriptlocation/indentpara.php");

# publish must load after wikilog for the wikilog publish feature to work
include_once("$FarmD/local/$scriptlocation/publish.php");

# spaces page names that are dates
include_once("$FarmD/local/$scriptlocation/custom-spacing.php");

?>